<?php

declare(strict_types=1);

namespace Drupal\book_library;

use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Entity\EntityListBuilder;

/**
 * Provides a list controller for the genre entity type.
 */
final class GenreListBuilder extends EntityListBuilder {

  /**
   * {@inheritdoc}
   */
  public function buildHeader(): array {
    $header['id'] = $this->t('ID');
    $header['title'] = $this->t('Genre');
    return $header + parent::buildHeader();
  }

  /**
   * {@inheritdoc}
   */
  public function buildRow(EntityInterface $entity): array {
    /** @var \Drupal\book_library\GenreInterface $entity */
    $row['id'] = $entity->id();
    $row['title'] = $entity->get('field_genre_title')->value;
    return $row + parent::buildRow($entity);
  }

}
